.\"	$NetBSD: geodeide.4,v 1.4 2005/07/06 06:36:10 fair Exp $
.\"
.\" Copyright (c) 2004 Manuel Bouyer.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd July 5, 2005
.Dt GEODEIDE 4
.Os
.Sh NAME
.Nm geodeide
.Nd AMD Geode IDE disk controllers driver
.Sh SYNOPSIS
.Cd "geodeide* at pci? dev ? function ? flags 0x0000"
.Sh DESCRIPTION
The
.Nm
driver supports the
.Tn AMD
Geode CS5530A and SC1100
.Tn IDE
controllers,
and provides the interface with the hardware for the
.Xr ata 4
driver.
.Pp
The 0x0002 flag forces the
.Nm
driver to disable
.Tn DMA
on chipsets for which
.Tn DMA
would normally be enabled.
This can be used as a debugging aid, or to work around
problems where the
.Tn IDE
controller is wired up to the system incorrectly.
.Sh SEE ALSO
.Xr ata 4 ,
.Xr atapi 4 ,
.Xr intro 4 ,
.Xr pci 4 ,
.Xr pciide 4 ,
.Xr wd 4 ,
.Xr wdc 4
.Sh BUGS
The SC1100 controller requires 4-byte aligned data transfers and
cannot handle transfers of exactly 64 kilobytes.
.Pp
The CS5530 multifunction chip/core's
.Tn IDE
section claims to be capable of
.Tn UDMA
mode 2
.Pq 33.3MB/s
but in practice using that mode swamps the controller so badly that
.Nm
limits the
.Tn UDMA
negotiation to mode 1
.Pq 25MB/s
so that the other functions of this chip continue to work.
.Pp
The
.Tn IDE DMA
engine in the CS5530 can only do transfers on cache-line
.Pq 16-byte
boundaries.
Attempts to perform
.Tn DMA
on any other alignment will crash the system.
This problem may also exist in the SC1100 since the CS5530 was its
direct predecessor, and it is not clear that National Semiconductor
fixed any bugs in it.
.Pp
The
.Nm
driver will reject attempts to
.Tn DMA
to buffers not aligned to the required boundary.
The
.Xr wd 4
disk driver will back off to
.Tn PIO
mode to accomplish these transfer requests, at reduced system performance.
